/*
 * lxdecq-f.u.c
 * Copyright (C) 2008-2010, 2013-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_u_forward(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxlist_type *dxlist_data;
	struct lxtext_type *lxtext_data;

	lxtext_data = context;

	dxlist_data = I_LIST(input[0]);

	if (1) {
	    unsigned type;
	    void *data;

	    type = lxtext_data->lxtype.code;

	    status = _libx1f4i0_tail_dllist(dxlist_data->list, &data);
	    if (status) {
		status =
		    _libx1f4i0_lxdecq_stat_list(lxtext_data->text, 0, status);
	    } else {
		unsigned link;

		type_effect(data, type);

		link = lxtext_data
		    - ((struct lxtext_type *)
		       ((struct lxdecq_type *)
			lxtext_data->text)->link_f.text);

		if (1) {
		    status = lxtext_data->lxtype.node
			(lxtext_data->lxtype.context,
			 (void **) (effect_data(data)), I_USER(input[1]),
			 lock_excase(dxlist_data));
		    if (status) {
			link = ~0;
		    } else {
		    }
		}

		link_effect(data, link);

		dxlist_data->size++;
	    }
	}
    } while (0);

    return status;
}
