/*
 * a1.m.c
 * Copyright (C) 2006-2011, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-types.h>
#include <c1.h>

int
x1f4_seek_shuffle(struct a1_shuffle_type *shuffle_data, unsigned *line)
{
    struct a1_node_type *node_data;

    node_data = shuffle_data->instant.fail_node;

    if (node_data) {
	unsigned deck;

	x1f4_look_program(node_data->aime, &deck);
	if (1) {
	    deck += node_data->offset;
	}

	*line = deck;
    } else {
	*line = 0;
    }

    return 0;
}
