/*
 * lxdash-d.k.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_k_derived(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_USER slip;
	struct dxdash_type *dxdash_data;
	struct lxdash_type *lxdash_data;
	struct lxtext_type *lxtext_data;

	lxtext_data = context;

	lxdash_data = lxtext_data->text;

	dxdash_data = I_LINE(input[1]);

	if (1) {
	    struct effect_type effect;
	    void *data;

	    effect.mode = I_MODE(input[2]);

	    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
	    if (status) {
		struct effect_type *effect_data;
		unsigned type;

		status = 0;

		effect_data = data;

		type = effect_data->type;
		if (type != lxtext_data->lxtype.code) {
		    l_MODE(0, output);
		    if (1) {
			break;
		    }
		} else {
		    slip = I_USER(&effect_data->fxdata);
		}
	    } else {
		status = _libx1f4i0_lxdash_n_logique
		    (context, &slip, input + 1);
		if (status) {
		    break;
		}
	    }
	}

	status = _libx1f4i0_lxcall_land_node
	    (&lxdash_data->link_v, &lxdash_data->link_e, &lxtext_data->lxtype,
	     slip, input[0]);
	if (status) {
	} else {
	    l_MODE(1, output);
	}
    } while (0);

    return status;
}
