/*
 * lxdecq-l.c.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <f_list.h>
#include <lxcall.h>
#include <lxdecq-defs.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_c_logique(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data, *dxlist_text;

    dxlist_data = I_LIST(input[0]);
    dxlist_text = I_LIST(input[1]);

    if (dxlist_data == dxlist_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxdecq_line_list(context, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_lxdecq_late_list
		(context, dxlist_data, dxtext, dxlist_text);
	    if (status) {
	    } else {
		status = _libx1f4i0_lxdecq_null_list
		    (context, NULL, dxlist_data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxdecq_swap_list(dxtext, dxlist_data);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxdecq_flat_list(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    if (status) {
    } else {
	l_LIST(dxlist_data, output);
    }

    return status;
}

