/*
 * lxline-e.r.c
 * Copyright (C) 2010, 2011, 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxline-inter.h>
#include <lxnote.h>
#include <lxrail.h>

static const struct x1f4_lxnote_type fail_note = {
/* *INDENT-OFF* */
    _libx1f4i0_lxrail_bset_rail,
    _libx1f4i0_lxrail_cfix_rail,
    _libx1f4i0_lxline_clip_line,
    _libx1f4i0_lxline_dset_line,
    _libx1f4i0_lxline_fini_line,
    _libx1f4i0_lxline_fold_line,
    _libx1f4i0_lxline_fset_line,
    NULL,
    NULL,
    _libx1f4i0_lxrail_near_rail,
    _libx1f4i0_lxline_pass_line,
    NULL,
    _libx1f4i0_lxline_seek_line,
    _libx1f4i0_lxline_suit_line,
    _libx1f4i0_lxline_tile_line,
    _libx1f4i0_lxrail_tune_rail,
    _libx1f4i0_lxrail_uset_rail,
    NULL,
    _libx1f4i0_lxline_wrap_line,
    X1f4_LXNOTE_ODDCOUNT | X1f4_LXNOTE_OFFSUITE | X1f4_LXNOTE_TRAVERSE
/* *INDENT-ON* */
};

int
x1f4_note_lxline(const struct x1f4_lxnote_type **lxnote)
{
    *lxnote = &fail_note;

    return 0;
}
