/*
 * lxmath-k.d.c
 * Copyright (C) 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxmath-drive.h>

#undef min
#define min(___T) \
    {									      \
	X1f4_E4_C_##___T ten0, ten1, side;				      \
									      \
	ten0 = I_##___T(input[0]);					      \
	ten1 = I_##___T(input[1]);					      \
									      \
	side = ten0 < ten1 ? ten0 : ten1;				      \
									      \
	l_##___T(side, output);						      \
	l_##___T(side, input[0]);					      \
    }

int
_libx1f4i0_lxmath_k180107_3(void *context, void *output, void **input)
{
    min(BILL);

    return 0;
}


int
_libx1f4i0_lxmath_k180107_4(void *context, void *output, void **input)
{
    min(MODE);

    return 0;
}


int
_libx1f4i0_lxmath_k180107_5(void *context, void *output, void **input)
{
    min(REAL);

    return 0;
}
