/*
 * lxpoll-e.x.c
 * Copyright (C) 2010, 2011, 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxpoll-inter.h>
#include <nt.h>

int
x1f4_clip_lxpoll(unsigned bits, const void *screen,
		 struct x1f4_nodetype_type **nodetype, int *poll3)
{
    int cpoll3;
    struct x1f4_nodetype_type *nodetype_data;

    nodetype_data = *nodetype;

    cpoll3 = *poll3;

    _libx1f4i0_lxpoll_type_poll(nodetype_data, cpoll3);

    cpoll3++;

    nodetype_data++;

    *poll3 = cpoll3;

    *nodetype = nodetype_data;

    return 0;
}
