/*
 * lxpoll-i.e.c
 * Copyright (C) 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxfile.h>
#include <lxpoll-inter.h>
#include <lxpoll-types.h>

int
_libx1f4i0_lxpoll_flat_file(void *reflex, void *ennuie)
{
    int excess, status;
    struct lxpoll_type *lxpoll_data;

    lxpoll_data = *((void **) ennuie + 2);

    status = _libx1f4i0_lxpoll_free_file
	(lxpoll_data, *(void **) ennuie, *((void **) ennuie + 1));

    excess = lxpoll_data->link_m.free(lxpoll_data->link_m.data, ennuie);
    if (excess) {
	status = _libx1f4i0_lxpoll_stat_free(lxpoll_data, status);
    }

    return status;
}
