/*
 * lead.0.c
 * Copyright (C) 2011-2012, 2016, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <unistd.h>

#include <aime.h>

#define I_MODE(i)			(*((X1f4_E4_C_MODE *) (i)))

static int lead_1701(void *, void *, void **);
static int lead_1702(void *, void *, void **);

const struct x1f4_function_type _libx1f4i0_lead_0[] = {
/* *INDENT-OFF* */
    {	"o_flush",		lead_1701,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL,			7		},
    {	"v_flush",		lead_1702,
	X1f4_E4_VOID,		NULL,		0,
	X1f4_E4_KEEP_CALL,			7		},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1		}
/* *INDENT-ON* */
};

static int
lead_1701(void *context, void *output, void **input)
{
    fflush(stdout);

    return 0;
}


static int
lead_1702(void *context, void *output, void **input)
{
    fflush(stderr);

    return 0;
}
